"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.callScfMethod = void 0;
const error_1 = require("../error");
async function callScfMethod(params, context) {
    var _a, _b;
    try {
        const methodName = params.methodCfg.calleeBody.fnName;
        const response = await context.app.callFunction({
            name: methodName,
            data: params.params || {},
        });
        if (response.code)
            throw new error_1.TCBError(`FnError.Scf${response.code}`, `${response.message}, requestId: ${response.requestId}`, {
                original: response,
            });
        return response.result;
    }
    catch (e) {
        if (e instanceof error_1.TCBError)
            throw e;
        let code = e.code || e.name;
        let message = e.message || '';
        if (code === 'FUNCTION_NOT_FOUND') {
            message = `找不到云开发云函数 ${(_b = (_a = params.methodCfg) === null || _a === void 0 ? void 0 : _a.calleeBody) === null || _b === void 0 ? void 0 : _b.fnName}`;
        }
        if (code) {
            code = `FnError.Scf.${code}`;
        }
        else {
            code = 'FnError.Scf';
        }
        throw new error_1.TCBError(code, `调用自定义连接器云函数方法失败: ${message}`, {
            original: e,
        });
    }
}
exports.callScfMethod = callScfMethod;
